/* %Z%%M% %I% %E% 1989 by Robin T. Miller. */

/****************************************************************************
 *									    *
 *			  COPYRIGHT (c) 1989 - 1995			    *
 *			   This Software Provided			    *
 *				     By					    *
 *			   MILLER W J & ASSOCIATES			    *
 *			       14 Aladdin Road 				    *
 *			      Windham, NH 03087				    *
 *			       (603) 890-8723				    *
 *									    *
 * Permission to use, copy, modify, distribute and sell this software and   *
 * its documentation for any purpose and without fee is hereby granted,	    *
 * provided that the above copyright notice appear in all copies and that   *
 * both that copyright notice and this permission notice appear in the	    *
 * supporting documentation, and that the name of the author not be used    *
 * in advertising or publicity pertaining to distribution of the software   *
 * without specific, written prior permission.				    *
 *									    *
 * THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, 	    *
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN	    *
 * NO EVENT SHALL HE BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL   *
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR    *
 * PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS  *
 * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF   *
 * THIS SOFTWARE.							    *
 *									    *
 ****************************************************************************/
/*
 * Modification History:
 *
 * November 22, 1995 by Robin Miller.
 *	Initial port to QNX 4.21 Operating System.
 */
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <time.h> 				/* CLK_TCK defined here */
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#ifdef sun
#  include <sys/param.h>
#  include <sys/timeb.h>
#else
#  include <sys/timeb.h>
#endif /* sun */

#if !defined(HZ)
#  if defined(CLK_TCK)
#    define HZ		CLK_TCK
#  else
#    define HZ		256
#    define CLK_TCK	HZ
#  endif /* defined(CLK_TCK) */
#endif /* !defined(HZ) */

#define TIME_TAPE				/* Enable tape timing.	*/
extern int errno;

#define FILE_TOTALS	"total_files"		/* For count of files.	*/
#define SUCCESS		0			/* Success status code. */
#define FAILURE		-1			/* Failure status code. */
#define WARNING		1			/* Warning status code.	*/
#define TRUE		1			/* Boolean TRUE value.	*/
#ifdef FALSE
#  undef FALSE
#endif
#define FALSE		!TRUE			/* Boolean FALSE value.	*/

#define BLOCK		512		/* Bytes in block. */
#define KBYTE		1024		/* Kilobytes. */
#define MBYTE		1048576		/* Megabytes. */
#define	BIG		0x7fffffff	/* Largest positive number.	*/
#define DEFAULT_SIZE	(32 * BLOCK)	/* Maximum bytes per transfer.	*/
#define DIR_SIZE	256		/* Size of directory path.	*/

typedef unsigned char *	iobuf_t;

extern int compare_flag, debug_flag, verbose_flag, verify_flag;
extern char *name;
extern iobuf_t compare_buffer, data_buffer;
extern char *directory_name, *input_file, *output_file;
extern int block_size, file_count, file_number;
extern long file_size, record_count, starting_record, total_size;
extern int total_files;
extern int skip_count, last_read;
extern int ifd, ofd;
extern FILE *fp, *fpi;
extern struct timeb stime, btime, etime;

/*
 * External Declarations:
 */
extern void print_time(clock_t time);
extern void report_time(void);
extern void terminate(int code);
extern int match(char *s);
extern int number(int big);
extern void usage(void);
extern unsigned short updcrc(
		unsigned short	icrc,
		unsigned char	*icp,
		unsigned int	icnt );
