.so ../trf_files/INIT.memo
.\" <<<<<<<<<< Date Format >>>>>>>>>>>>>>>>>>>>>>>>>>>>
.	\" Use '_Date'     to get current date/time stamp
.	\" Use '_FileDate' to get last modified date of file
.so _FileDate
.\" .so _Date
.\" <<<<<<<<<<< String Definitions >>>>>>>>>>>>>>>>>>>>>
.	\" Uncomment next line for nroff'd short screen format
.\" .SC
.ds S~ Tape Duplication Program.
.ds T~ Listed Personnel
.so /usr/users1/miller/memo/INIT.memo
.so /usr/users1/miller/memo/_Cover
.so /usr/users1/miller/memo/I_memo
.\" <<<<<<<<<<<< Start Text Here >>>>>>>>>>>>>>>>>>>>>>
.nh 1 Introduction.
The end of last year, I wrote a tape duplication program named \fItape_dup\fP
for copying Sun distribution tapes.  This program has been used successfully
to copy Sun/386i and Sun/Sparc quarter inch distribution tapes, however it
should work just as well with half inch and 8mm tapes.  The program currently
runs on Sun systems, but should work with any version of Unix since standard
system calls are used.  There is code for reporting elapsed time, but this
is conditionalized for Sun systems.
.nh 1 Justification.
Prior to writing this program, the popular method of duplicating tapes
was to use the \fIdd\fP utility for copying files from tape to disk, and
then from disk back to tape.  Although this method works, no verification
of the data is done when writing the new tape.  If there are problems using
the new tape, there was always a question whether the tape had been
recreated exactly like the original.
.nh 1 The \fItape_dup\fP Program.
The \fItape_dup\fP program is mostly a modified version of the \fIdd\fP
utility except an additional information file is created which is used to
verify the data before writing to a new tape.  If there are any
inconsistancies with the data files on the disk, \fItape_dup\fP will
detect them and inform the user.
.nh 2 Files Created By \fItape_dup\fP.
There are two files created for each file read from tape.  The files are
named \fIfile_#\fP and \fIfile_#.info\fP, where # is the file number on
the tape.
.nh 3 Data File.
The first file (\fIfile_#\fP) is the actual raw data from the
tape.  The tape file may have been created using \fIdd\fP, \fIbar\fP,
\fItar\fP, \fIcpio\fP, \fIdump\fP, or whatever, \fItape_dup\fP doesn't
know and doesn't care.  \fItape_dup\fP simply reads data from the tape
and writes it to the disk file until a tape file mark is detected which
indicates end of file.  A second file mark or end of recorded media,
indicates the end of tape.  The file number is incremented and used as
part of the file name each time a file mark is detected.
.nh 3 Information File.
The second file (\fIfile_#.info\fP) contains information for verifying
the data file.  The format of this file is:
.sp 0.5
.nf
	record_number byte_count crc_bytes
	      .           .          .
	      .           .          .
	-1 total_bytes 0
.fi
.sp 0.5
When reading the original tape, \fItape_dup\fP writes an entry containing
the record number, byte count, and CRC bytes.  When the end of file is
detected, it then writes the total number of bytes read.  When creating a
new tape, \fItape_dup\fP recalculates the CRC of each record in the data
file, and compares that with the corresponding entry in the information file.
Since \fItape_dup\fP writes exactly the same number of bytes read from
the original tape, an exact duplication is assured.
.PP
The Cyclic Redundancy Check (CRC) bytes are created from a program which
came from the Usenet (\fIfast_crc.c\fP).  The CRC calculation is the same
as that used by the \fIxmodem\fP communications program.
.nh 3 Totals File.
The total number of files read from the tape is written to a file named
\fItotal_files\fP so \fItape_dup\fP knows how many files to write when
creating a new tape.
.nh 1 Program Options.
I've attempted to make \fItape_dup\fP very easy to use, so there are only
a few options and most default appropriately.  The program options are:
.sp 0.5
.TS
center box tab (|) box;
cfB | cfB | cfB
c | c | c.
Option|Description|Default
=
if=filename|The input file to read.|None
_
of=filename|The output file to write.|None
_
bs=value|The block size to read.|32Kb
_
directory=path|The directory name of data files.|.
_
enable=flag|Enable a particular flag.|None
_
disable=flag|Disable a particular flag.|None
=
|Flags to enable/disable:|
_
debug|Debug output.|Disabled
_
stats|Display statistics.|Enabled
_
verbose|Verbose output.|Enabled
_
verify|Verify data.|Disabled
.TE
.nh 2 Program Notes.
.nh 3 Sun Tape Driver Problem.
On the Sun/386i, the no-rewind tape device (\fI/dev/nrst0\fP) must be
specified as the input file due to a bug in the tape device driver.
When detecting end of file (EOF), the driver doesn't reset the EOF marker
so the next tape file can be read (it returns 0 on the next read which
indicates end of tape).  To avoid this problem, the tape device is closed
and re-opened between each tape file.  If the rewinding tape
device (\fI/dev/rst0\fP) is used, \fItape_dup\fP keeps re-reading
the first tape file and loops forever eventually filling up the disk.
.nh 3 Data/Information Files.
On both input (\fIif=\fP) and output (\fIof=\fP), data and information files
are written to or read from the current directory.  This default can be
overridden by by specifying the "\fIdirectory=path\fP" option.
During input or output, \fItape_dup\fP can be aborted by pressing your
interrupt key, and statistics up to that point will be displayed.
.nh 3 Block Size.
The default block size chosen (32Kb) seems to keep the Archive Viper quarter
inch tape drive streaming the best when reading the tape.  On output, the byte
count contained within the information file is used when writing each record
(the \fIbs=\fP option is ignored).
.nh 3 Data Verification.
The \fIverify\fP option can be enabled if you simply want to verify the
integrity of the data files stored on the disk.  \fItape_dup\fP reads the
data files and compares the CRC bytes with those in the information file.
.PP
If the \fIverify\fP option is enabled with an input file, \fItape_dup\fP
simply reads all the files on the tape and reports statistics.  The data
read from the tape isn't written to disk files.  This is useful to do a
manual verification of tape files to disk files, or simply to determine
how many files and the size of each file on the tape.
.nh 3 \fItape_dup\fP Examples.
.sp 0.5
.nf
cg-s% cd /proto/sun_tapes/sun386i/4.0.1/devel
cg-s% du -s .
18847 .
cg-s% 
cg-s% tape_dup enable=verify
A total of 12 files will be verified.
File 1: Processed 2 records containing 65536 bytes, elapsed = 0m00.18s
File 2: Processed 1 records containing 2560 bytes, elapsed = 0m00.05s
File 3: Processed 178 records containing 5832704 bytes, elapsed = 0m34.85s
File 4: Processed 117 records containing 3833856 bytes, elapsed = 0m21.93s
File 5: Processed 75 records containing 2457600 bytes, elapsed = 0m14.76s
File 6: Processed 8 records containing 262144 bytes, elapsed = 0m01.53s
File 7: Processed 14 records containing 458752 bytes, elapsed = 0m02.58s
File 8: Processed 65 records containing 2129920 bytes, elapsed = 0m11.00s
File 9: Processed 8 records containing 262144 bytes, elapsed = 0m01.33s
File 10: Processed 20 records containing 655360 bytes, elapsed = 0m03.38s
File 11: Processed 99 records containing 3244032 bytes, elapsed = 0m16.91s
File 12: Processed 1 records containing 512 bytes, elapsed = 0m00.05s
A total of 12 files consisting of 19205120 bytes were processed.
The total time to verify 18755.00 Kbytes (18.32 Mbytes) was 1m49.96s.
cg-s% 
cg-s% setenv TAPE /dev/nrst0
cg-s% mt rewind
cg-s% tape_dup of=/dev/rst0
A total of 12 files will be written to the tape.
File 1: Processed 2 records containing 65536 bytes, elapsed = 0m09.11s
File 2: Processed 1 records containing 2560 bytes, elapsed = 0m01.76s
File 3: Processed 178 records containing 5832704 bytes, elapsed = 0m56.01s
File 4: Processed 117 records containing 3833856 bytes, elapsed = 0m44.50s
File 5: Processed 75 records containing 2457600 bytes, elapsed = 0m26.46s
File 6: Processed 8 records containing 262144 bytes, elapsed = 0m03.33s
File 7: Processed 14 records containing 458752 bytes, elapsed = 0m05.10s
File 8: Processed 65 records containing 2129920 bytes, elapsed = 0m22.30s
File 9: Processed 8 records containing 262144 bytes, elapsed = 0m03.40s
File 10: Processed 20 records containing 655360 bytes, elapsed = 0m09.13s
File 11: Processed 99 records containing 3244032 bytes, elapsed = 0m38.00s
File 12: Processed 1 records containing 512 bytes, elapsed = 0m00.83s
A total of 12 files consisting of 19205120 bytes were processed.
The total time to write 18755.00 Kbytes (18.32 Mbytes) was 3m41.98s.
cg-s% 
.fi
.B1
Note the use of the no rewind device (\fI/dev/nrst0\fP) when reading the tape.
.B2
.nf
cg-s% tape_dup if=/dev/nrst0 enable=verify
File 1: Processed 2 records containing 65536 bytes, elapsed = 0m00.33s
File 2: Processed 1 records containing 2560 bytes, elapsed = 0m00.01s
File 3: Processed 178 records containing 5832704 bytes, elapsed = 0m53.98s
File 4: Processed 117 records containing 3833856 bytes, elapsed = 0m37.56s
File 5: Processed 75 records containing 2457600 bytes, elapsed = 0m22.71s
File 6: Processed 8 records containing 262144 bytes, elapsed = 0m02.16s
File 7: Processed 14 records containing 458752 bytes, elapsed = 0m04.00s
File 8: Processed 65 records containing 2129920 bytes, elapsed = 0m19.58s
File 9: Processed 8 records containing 262144 bytes, elapsed = 0m02.16s
File 10: Processed 20 records containing 655360 bytes, elapsed = 0m05.86s
File 11: Processed 99 records containing 3244032 bytes, elapsed = 0m31.85s
File 12: Processed 1 records containing 512 bytes, elapsed = 0m00.00s
A total of 12 files consisting of 19205120 bytes were processed.
The total time to verify 18755.00 Kbytes (18.32 Mbytes) was 3m06.30s.
cg-s% 
.fi
.B1
When reading tapes using \fItape_dup\fP, the following error is reported
by the tape driver after the last file on the tape.  This is a non-fatal
error which should be ignored.  Actually an error shouldn't be reported
at all, since a "\fIblank check\fP" is the expected error at the end of
recorded media which indicates the logical end of tape.
.B2
.nf
cg-s% tail /usr/adm/messages
Apr  3 17:57:51 cg-s %$
Apr  3 17:57:51 cg-s 

Apr  3 18:15:10 cg-s st4:  failed cmd =  8  1  0  0  40  0  

Apr  3 18:15:10 cg-s st%{d%|4%} error:  sense key(0x%{x%|8%}): %{s%|blank check%}
Apr  3 18:15:11 cg-s sense = %{x%|f0%}  %{x%|0%}  %{x%|8%}  %{x%|0%}  %{x%|0%}
 %{x%|0%}  %{x%|40%}  %{x%|6%}  %{x%|0%}  %{x%|0%}  %{x%|0%}  %{x%|0%}
Apr  3 18:15:11 cg-s %$
Apr  3 18:15:10 cg-s 

cg-s% mt rewind
cg-s% tape_dup if=/dev/nrst0 directory=/tmp/robin/tmp
File 1: Processed 2 records containing 65536 bytes, elapsed = 0m00.50s
File 2: Processed 1 records containing 2560 bytes, elapsed = 0m00.00s
File 3: Processed 178 records containing 5832704 bytes, elapsed = 0m54.25s
File 4: Processed 117 records containing 3833856 bytes, elapsed = 0m38.25s
File 5: Processed 75 records containing 2457600 bytes, elapsed = 0m23.15s
File 6: Processed 8 records containing 262144 bytes, elapsed = 0m02.90s
File 7: Processed 14 records containing 458752 bytes, elapsed = 0m03.90s
File 8: Processed 65 records containing 2129920 bytes, elapsed = 0m19.46s
File 9: Processed 8 records containing 262144 bytes, elapsed = 0m02.28s
File 10: Processed 20 records containing 655360 bytes, elapsed = 0m06.33s
File 11: Processed 99 records containing 3244032 bytes, elapsed = 0m32.96s
File 12: Processed 1 records containing 512 bytes, elapsed = 0m00.25s
A total of 12 files consisting of 19205120 bytes were processed.
The total time to read 18755.00 Kbytes (18.32 Mbytes) was 3m14.63s.
cg-s% 
cg-s% mt rewind
cg-s% /usr/bin/diff -s . /tmp/robin/tmp
Files ./file_1 and /tmp/robin/tmp/file_1 are identical
Files ./file_1.info and /tmp/robin/tmp/file_1.info are identical
Files ./file_10 and /tmp/robin/tmp/file_10 are identical
Files ./file_10.info and /tmp/robin/tmp/file_10.info are identical
Files ./file_11 and /tmp/robin/tmp/file_11 are identical
Files ./file_11.info and /tmp/robin/tmp/file_11.info are identical
Files ./file_12 and /tmp/robin/tmp/file_12 are identical
Files ./file_12.info and /tmp/robin/tmp/file_12.info are identical
Files ./file_2 and /tmp/robin/tmp/file_2 are identical
Files ./file_2.info and /tmp/robin/tmp/file_2.info are identical
Files ./file_3 and /tmp/robin/tmp/file_3 are identical
Files ./file_3.info and /tmp/robin/tmp/file_3.info are identical
Files ./file_4 and /tmp/robin/tmp/file_4 are identical
Files ./file_4.info and /tmp/robin/tmp/file_4.info are identical
Files ./file_5 and /tmp/robin/tmp/file_5 are identical
Files ./file_5.info and /tmp/robin/tmp/file_5.info are identical
Files ./file_6 and /tmp/robin/tmp/file_6 are identical
Files ./file_6.info and /tmp/robin/tmp/file_6.info are identical
Files ./file_7 and /tmp/robin/tmp/file_7 are identical
Files ./file_7.info and /tmp/robin/tmp/file_7.info are identical
Files ./file_8 and /tmp/robin/tmp/file_8 are identical
Files ./file_8.info and /tmp/robin/tmp/file_8.info are identical
Files ./file_9 and /tmp/robin/tmp/file_9 are identical
Files ./file_9.info and /tmp/robin/tmp/file_9.info are identical
Files ./total_files and /tmp/robin/tmp/total_files are identical
cg-s%
.fi
.\" <<<<<<<<<<<< End   Text Here >>>>>>>>>>>>>>>>>>>>>>
.Si		\" Signature Line
.		\" Insert full path/file name
.so _Path
.\" *******************************************************************
.Co	\" For single page memos, delete this line and the next 2.
.so /usr/users1/miller/memo/_Cover
.so /usr/users1/miller/memo/I_memo
.\" *******************************************************************
.sp 2
.tl ^\fIList:\fR^^^
.TS
tab (|);
l l. 
Dave Alexander | 200-2-9F
Burke Anderson | 200-3-5B
Kathy Barnes | 200-2-5B
Tim Baxter | 200-2-5P
Sal Calascibetta | 200-3-9M
Randy Chandler | 200-2-5P
Earl Christianson | 200-3-5B
Mike Conley | 200-2-5B
Steve Grindel | 200-2-5S
Stan Hackney | 200-3-5B
Bill Hawk | 200-2-5P
Dave Kilgrow | 200-3-7K
Tom Lloyd | 200-2-9F
Jeanne Lucivero | 200-3-5B
Tom Quatrale | 200-2-5P
Vicki Quick | 200-4-9B
Jan Reimers | 200-2-9F
Stephanie Santarelli | 200-3-5B
Lee Silverman | 200-2-9F
Ted Squire | 200-2-9F
Brian Steeves | 200-3-5B
Dick Stokken | 200-3-5B
Lee Ternullo | 200-2-9F
Jeff Weber | 200-2-9F
.TE
